' Name: OpenRokn
' Homepage: http://openrokn.sourceforge.net
' Description: Open source Roku channel building kit
' Author: kavulix
' 
' Copyright (C) 2011 kavulix
' 
' Licensed under the Apache License, Version 2.0 (the "License");
' you may not use this file except in compliance with the License.
' You may obtain a copy of the License at
'
' http://www.apache.org/licenses/LICENSE-2.0
'
' Unless required by applicable law or agreed to in writing, software
' distributed under the License is distributed on an "AS IS" BASIS,
' WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
' See the License for the specific language governing permissions and
' limitations under the License.

Function saveZip() As Object
	extension = {
		title: "Zip code registry",
		description: "Save zip code to the registry and display it on a settings screen",
		isEnabled: true,
		enableForItems: ["settings"],
		buttonLabel: "Change zip code",
		codeToExecute: "execSaveZip()",
		enableParagraph: true,
		paragraphCodeToExecute: "displayZip()"
	}
	return extension
End Function

Function execSaveZip() As Boolean
	regvalue = getStrValFromReg("zipcode", "profile")
	keyboard = createKeyboard("Zip code", "enter a zip code", regvalue, 5)
	port = CreateObject("roMessagePort")
	keyboard.SetMessagePort(port)
	keyboard.Show()

	while true
		msg = wait(0, port)
		if type(msg) = "roKeyboardScreenEvent" then
			if msg.isScreenClosed() then
				return false
			elseif msg.isButtonPressed()
				if msg.GetIndex() = 1 then
					regvalue = keyboard.GetText()
					if len(regvalue) = 5 then
						success = saveStrValToReg("zipcode", regvalue, "profile")
						if success then
							alert("Alert", "The zip code was saved successfully to the Roku registry.")
						else
							alert("Alert", "The zip code was not saved!")
						endif
						return success
					else
						alert("Alert", "You must enter a valid zip code in order to continue.")
					endif
				else
					return false
				endif
			endif
		endif
	end while
End Function

Function displayZip() As String
	regvalue = getStrValFromReg("zipcode", "profile")
	if len(regvalue) < 1 then
		regvalue = "not set"
	endif
	return "Zip code: " + regvalue
End Function
