' Name: OpenRokn
' Homepage: http://openrokn.sourceforge.net
' Description: Open source Roku channel building kit
' Author: kavulix
' 
' Copyright (C) 2011 kavulix
' 
' Licensed under the Apache License, Version 2.0 (the "License");
' you may not use this file except in compliance with the License.
' You may obtain a copy of the License at
'
' http://www.apache.org/licenses/LICENSE-2.0
'
' Unless required by applicable law or agreed to in writing, software
' distributed under the License is distributed on an "AS IS" BASIS,
' WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
' See the License for the specific language governing permissions and
' limitations under the License.

Function showtimesByZip() As Object
	extension = {
		title: "Showtimes by zip code",
		description: "Retrieve movie showtimes for a zip code",
		isEnabled: true,
		enableForItems: ["settings"],
		buttonLabel: "Local movie showtimes",
		codeToExecute: "execShowtimesByZip(xe)",
		enableParagraph: false,
		paragraphCodeToExecute: ""
	}
	return extension
End Function

Function execShowtimesByZip(xe As Object) As Boolean
	showtimesUrl = "http://www.google.com/movies?near="

	regvalue = getStrValFromReg("zipcode", "profile")
	if len(regvalue) < 5 then
		if not(execSaveZip()) then return false
		regvalue = getStrValFromReg("zipcode", "profile")
	endif

	showtimesUrl = showtimesUrl + regvalue

	' create an item element as a child node of the settings element
	' if it doesnt already exist. settings items are not intended to
	' support child item nodes but in an extension you can pretty
	' much make up your own rules. the code you use here doesnt have
	' to comply with the orml specification.
	if xe.item.Count() < 1 then
		item = xe.AddElement("item")
		item.AddAttribute("type", "document")
		item.AddAttribute("title", regvalue)
		item.AddAttribute("striphtml", "true")
		item.AddAttribute("stripews", "true")
		item.AddAttribute("regexfilter", "^.+<div id=movie_results>|<div id=navbar.+$")
	endif

	' update the url attribute each time this extension is executed
	' since the zip code in the registry may have been changed
	xe.item[0].AddAttribute("url", showtimesUrl)
	displayDocument(xe@title, xe.item[0])

	return true
End Function

